org.apache.http.impl.execchain

## Class MainClientExec

- java.lang.Object
- - org.apache.http.impl.execchain.MainClientExec

- All Implemented Interfaces:
    ClientExecChain

      @Contract(threading=IMMUTABLE_CONDITIONAL)
      public class MainClientExec
      extends Object
      implements ClientExecChain

  The last request executor in the HTTP request execution chain that is responsible for execution of request / response exchanges with the opposite endpoint. This executor will automatically retry the request in case of an authentication challenge by an intermediate proxy or by the target server.
  Since:
    4.3

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MainClientExec(org.apache.http.protocol.HttpRequestExecutor requestExecutor, HttpClientConnectionManager connManager, org.apache.http.ConnectionReuseStrategy reuseStrategy, ConnectionKeepAliveStrategy keepAliveStrategy, AuthenticationStrategy targetAuthStrategy, AuthenticationStrategy proxyAuthStrategy, UserTokenHandler userTokenHandler)`
    `MainClientExec(org.apache.http.protocol.HttpRequestExecutor requestExecutor, HttpClientConnectionManager connManager, org.apache.http.ConnectionReuseStrategy reuseStrategy, ConnectionKeepAliveStrategy keepAliveStrategy, org.apache.http.protocol.HttpProcessor proxyHttpProcessor, AuthenticationStrategy targetAuthStrategy, AuthenticationStrategy proxyAuthStrategy, UserTokenHandler userTokenHandler)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CloseableHttpResponse` | `execute(HttpRoute route, HttpRequestWrapper request, HttpClientContext context, HttpExecutionAware execAware)` Executes th request either by transmitting it to the target server or by passing it onto the next executor in the request execution chain.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MainClientExec

          public MainClientExec(org.apache.http.protocol.HttpRequestExecutor requestExecutor,
                        HttpClientConnectionManager connManager,
                        org.apache.http.ConnectionReuseStrategy reuseStrategy,
                        ConnectionKeepAliveStrategy keepAliveStrategy,
                        org.apache.http.protocol.HttpProcessor proxyHttpProcessor,
                        AuthenticationStrategy targetAuthStrategy,
                        AuthenticationStrategy proxyAuthStrategy,
                        UserTokenHandler userTokenHandler)

      Since:
        4.4

    - #### MainClientExec

          public MainClientExec(org.apache.http.protocol.HttpRequestExecutor requestExecutor,
                        HttpClientConnectionManager connManager,
                        org.apache.http.ConnectionReuseStrategy reuseStrategy,
                        ConnectionKeepAliveStrategy keepAliveStrategy,
                        AuthenticationStrategy targetAuthStrategy,
                        AuthenticationStrategy proxyAuthStrategy,
                        UserTokenHandler userTokenHandler)

  - ### Method Detail

    - #### execute

          public CloseableHttpResponse execute(HttpRoute route,
                                      HttpRequestWrapper request,
                                      HttpClientContext context,
                                      HttpExecutionAware execAware)
                                        throws IOException,
                                               org.apache.http.HttpException

      Description copied from interface: `ClientExecChain`
      Executes th request either by transmitting it to the target server or by passing it onto the next executor in the request execution chain.
      Specified by:
        `execute` in interface `ClientExecChain`
      Parameters:
        `route` - connection route.
        `request` - current request.
        `context` - current HTTP context.
        `execAware` - receiver of notifications of blocking I/O operations.
      Returns:
        HTTP response either received from the opposite endpoint or generated locally.
      Throws:
        `IOException` - in case of a I/O error. (this type of exceptions are potentially recoverable).
        `org.apache.http.HttpException` - in case of an HTTP protocol error (usually this type of exceptions are non-recoverable).

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.